/*
 *	  WindowsSevenZipWrapper.java
 *    A task to find a free folder to put something in
 *
 *    Copyright (C) 2008 New Zealand Digital Library, http://www.nzdl.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package org.greenstone.anttasks;

import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import java.io.File;
import java.io.IOException;

/**
 * Returns a path, based on the given path, which does not exist on the filesystem
 * If the given path doesn't exist on the system, just returns the path
 * If the given path does exist, return the path appended with "(n)" where
 * where n is the lowest possible integer greater than 1 which would result in a
 * path that does not exist on the file system.
 */
public class WindowsSevenZipWrapper extends Task {

	private String task = null;
	private File input = null;
	private File output = null;

	public void execute() {

		//check both attributes set
		if ( task != null && task != "decode" ) {
			throw new BuildException( "Error - Only task supported is 'decode' !!" );
		}

		if ( input == null ) {
			throw new BuildException( "Error - No input specified !!" );
		}

		if ( output == null ) {
			throw new BuildException( "Error - No output specified !!" );
		}

		try {
			String[] command = new String[] { "7za.exe", "x", input.getPath() };
			Process child = Runtime.getRuntime().exec(command);
		} catch (IOException e) {
			throw new BuildException( "Error - Problem running 7za.exe !!" );
		}

	}

	public void setOutput( File output ) {
		this.output = output;
	}

	public void setInput( File input ) {
		this.input = input;
	}

	public void setTask( String task ) {
		this.task = task;
	}

}
